VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Movie8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
Attribute VB_HelpID=2016
Option Explicit

Public Key As String

Private mvarFileName As String
Private mvarName_ As String
Private mvarMediaControl As IMediaControl 'MediaControl Object
Private mvarBasicAudio  As IBasicAudio 'Basic Audio Object
Private mvarBasicVideo As IBasicVideo 'Basic Video Object
Private mvarMediaEvent As IMediaEvent 'MediaEvent Object
Private mvarVideoWindow As IVideoWindow 'VideoWindow Object
Private mvarMediaPosition As IMediaPosition 'MediaPosition Object
Private mvarVolume As Long
Private mvarBalance As Long
Private mvarVideoWindowWidth As Long
Private mvarVideoWindowHeight As Long
Private mvarVideoWindowLeft As Long
Private mvarVideoWindowTop As Long
Private mvarPlayRate As Long
Private mvarDuration As Double
Private mvarIsPlaying As Boolean
Private mvarVideoWindowCaption As String
Private mvarVideoWindowStyle As eVideoWindowStyles

Public Enum eVideoWindowStyles
'##EN Video player window styles enumeration.
    eFullScreenStyle = 1
    '##EM eFullScreenStyle The window created by DirectShow will have no borders and title bar. Simular to full screen mode.
    eWindowStyle = 0
    '##EM eWindowStyle The window created by DirectShow will look like a standard windows form with title bar and border.
End Enum

Attribute Key.VB_VarHelpID = 2017
Public Property Let VideoWindowStyle(ByVal vData As eVideoWindowStyles)
Attribute VideoWindowStyle.VB_HelpID = 2018
Attribute VideoWindowStyle.VB_Description = "Retrieves/sets the type for the MovieEngine8 created window.  "
    mvarVideoWindowStyle = vData
End Property

Public Property Get VideoWindowStyle() As eVideoWindowStyles
'##BD Retrieves/sets the type for the MovieEngine8 created window.
    VideoWindowStyle = mvarVideoWindowStyle
End Property

Public Property Let VideoWindowCaption(ByVal vData As String)
Attribute VideoWindowCaption.VB_HelpID = 2019
Attribute VideoWindowCaption.VB_Description = "Retrieves/sets the caption for the MovieEngine8 created window.  "
    mvarVideoWindowCaption = vData
End Property

Public Property Get VideoWindowCaption() As String
'##BD Retrieves/sets the caption for the MovieEngine8 created window.
    VideoWindowCaption = mvarVideoWindowCaption
End Property

Public Property Get IsPlaying() As Boolean
Attribute IsPlaying.VB_HelpID = 2020
Attribute IsPlaying.VB_Description = "Determines if the movie stream is playing."
'##BD Determines if the movie stream is playing.
    IsPlaying = mvarIsPlaying
End Property

Public Property Get BitRate() As Long
Attribute BitRate.VB_HelpID = 2021
Attribute BitRate.VB_Description = "Retrieves an approximate bit rate for the video stream."
'##BD Retrieves an approximate bit rate for the video stream.
    On Error Resume Next
    
    BitRate = mvarBasicVideo.BitRate
End Property

Public Property Get AverageTimePerFrame() As Double
Attribute AverageTimePerFrame.VB_HelpID = 2022
Attribute AverageTimePerFrame.VB_Description = "Retrieves the average time between successive frames in 100-nanosecond units."
'##BD Retrieves the average time between successive frames in 100-nanosecond units.
    On Error Resume Next
    
    AverageTimePerFrame = mvarBasicVideo.AvgTimePerFrame
End Property

Public Property Get Position() As Double
Attribute Position.VB_HelpID = 2023
Attribute Position.VB_Description = "Retrieves the current position, relative to the total duration of the stream."
'##BD Retrieves the current position, relative to the total duration of the stream.
    On Error Resume Next
    
    Position = Round(mvarMediaPosition.CurrentPosition, 2)
End Property

Public Property Get Duration() As Double
Attribute Duration.VB_HelpID = 2024
Attribute Duration.VB_Description = "Retrieves the duration of the stream."
'##BD Retrieves the duration of the stream.
    Duration = mvarDuration
End Property

Public Property Let PlayRate(ByVal vData As Long)
Attribute PlayRate.VB_HelpID = 2025
Attribute PlayRate.VB_Description = "Retrieves/sets the playback rate.  "
    On Error Resume Next
    
    mvarPlayRate = vData
    mvarMediaPosition.Rate = vData
End Property

Public Property Get PlayRate() As Long
'##BD Retrieves/sets the playback rate.
    PlayRate = mvarPlayRate
End Property

Public Property Let VideoWindowTop(ByVal vData As Long)
Attribute VideoWindowTop.VB_HelpID = 2026
Attribute VideoWindowTop.VB_Description = "Retrieves/sets the vertical position for the MovieEngine8 created window.  "
    mvarVideoWindowTop = vData
End Property

Public Property Get VideoWindowTop() As Long
'##BD Retrieves/sets the vertical position for the MovieEngine8 created window.
    VideoWindowTop = mvarVideoWindowTop
End Property

Public Property Let VideoWindowLeft(ByVal vData As Long)
Attribute VideoWindowLeft.VB_HelpID = 2027
Attribute VideoWindowLeft.VB_Description = "Retrieves/sets the horizontal position for the MovieEngine8 created window.  "
    mvarVideoWindowLeft = vData
End Property

Public Property Get VideoWindowLeft() As Long
'##BD Retrieves/sets the horizontal position for the MovieEngine8 created window.
    VideoWindowLeft = mvarVideoWindowLeft
End Property

Public Property Let VideoWindowHeight(ByVal vData As Long)
Attribute VideoWindowHeight.VB_HelpID = 2028
Attribute VideoWindowHeight.VB_Description = "Retrieves/sets the height for the MovieEngine8 created window.  "
    mvarVideoWindowHeight = vData
End Property

Public Property Get VideoWindowHeight() As Long
'##BD Retrieves/sets the height for the MovieEngine8 created window.
    VideoWindowHeight = mvarVideoWindowHeight
End Property

Public Property Let VideoWindowWidth(ByVal vData As Long)
Attribute VideoWindowWidth.VB_HelpID = 2029
Attribute VideoWindowWidth.VB_Description = "Retrieves/sets the width for the MovieEngine8 created window.  "
    mvarVideoWindowWidth = vData
End Property

Public Property Get VideoWindowWidth() As Long
'##BD Retrieves/sets the width for the MovieEngine8 created window.
    VideoWindowWidth = mvarVideoWindowWidth
End Property

Public Property Let Balance(ByVal vData As Long)
Attribute Balance.VB_HelpID = 2030
Attribute Balance.VB_Description = "Retrieves/sets the balance for the audio signal.  "
    On Error Resume Next
    
    mvarBalance = vData
    mvarBasicAudio.Balance = vData
End Property

Public Property Get Balance() As Long
'##BD Retrieves/sets the balance for the audio signal.
    Balance = mvarBalance
End Property

Public Property Let Volume(ByVal vData As Long)
Attribute Volume.VB_HelpID = 2031
Attribute Volume.VB_Description = "Retrieves/sets the volume (amplitude) of the audio signal.  "
    On Error Resume Next
    
    mvarVolume = vData
    mvarBasicAudio.Volume = vData
End Property

Public Property Get Volume() As Long
'##BD Retrieves/sets the volume (amplitude) of the audio signal.
    Volume = mvarVolume
End Property

Public Function Use(Optional ByVal Owner As Long = 0) As Boolean
Attribute Use.VB_HelpID = 2032
Attribute Use.VB_Description = "This method readies the movie for playing. This method must be called prior to using any of the methods or properties of this object."
'##BD This method readies the movie for playing. This method must be called prior to using any of the methods or properties of this object.

'##PD Owner Windows handle of the owner of this movie stream. Set this to a picture box or something like that if you wish to play the movie on that source. If left at zero MovieEngine8 will create a window.
    On Error GoTo Handler
    
    'Error checking.
    If mvarFileName = "" Then Exit Function
    
    'Setup main object.
    Set mvarMediaControl = New FilgraphManager 'Instantiate a filter graph for the requested file format.
    Call mvarMediaControl.RenderFile(mvarFileName)
    
    'Setup Audio object.
    Set mvarBasicAudio = mvarMediaControl
    mvarBasicAudio.Volume = mvarVolume
    mvarBasicAudio.Balance = mvarBalance
    
    'Setup Video object.
    Set mvarVideoWindow = mvarMediaControl
    If VideoWindowStyle = eFullScreenStyle Then mvarVideoWindow.WindowStyle = CLng(&H6000000)
    mvarVideoWindow.Caption = mvarVideoWindowCaption
    mvarVideoWindow.Top = mvarVideoWindowTop
    mvarVideoWindow.Left = mvarVideoWindowLeft
    mvarVideoWindow.Width = mvarVideoWindowWidth / Screen.TwipsPerPixelX
    mvarVideoWindow.Height = mvarVideoWindowHeight / Screen.TwipsPerPixelY
    mvarVideoWindow.Owner = Owner 'window owner
    
    'Setup Media Event object.
    Set mvarMediaEvent = mvarMediaControl
    
    'Setup Media Position object and rate.
    Set mvarMediaPosition = mvarMediaControl
    mvarMediaPosition.Rate = mvarPlayRate
    
    mvarDuration = Round(mvarMediaPosition.Duration, 2)
    Set mvarBasicVideo = mvarMediaControl
    
    Use = True
    Exit Function
    
Handler:
    If Err = 445 Or 430 Then
        Resume Next
    Else
        Call VEngine.FireErrorEvent(Err.Number, Err.Description, "Movie8 | Use Function")
    End If
    Use = False
End Function

Public Property Let Name_(ByVal vData As String)
Attribute Name_.VB_HelpID = 2033
Attribute Name_.VB_Description = "Name of the movie within the collection.  "
    mvarName_ = vData
End Property

Public Property Get Name_() As String
'##BD Name of the movie within the collection.
    Name_ = mvarName_
End Property

Public Property Let FileName(ByVal vData As String)
Attribute FileName.VB_HelpID = 2034
Attribute FileName.VB_Description = "Path of the movie file.  "
    mvarFileName = vData
End Property

Public Property Get FileName() As String
'##BD Path of the movie file.
    FileName = mvarFileName
End Property

Private Sub Class_Initialize()
    mvarBalance = 0
    mvarVolume = 0
    mvarVideoWindowStyle = eWindowStyle
End Sub

Private Sub Class_Terminate()
    On Error Resume Next
    
    Call mvarMediaControl.Stop
    Set mvarMediaControl = Nothing
    Set mvarBasicAudio = Nothing
    Set mvarBasicVideo = Nothing
    Set mvarMediaEvent = Nothing
    Set mvarVideoWindow = Nothing
    Set mvarMediaPosition = Nothing
End Sub

Public Sub PlayMovie(Optional ByVal StartingPosition = 0)
Attribute PlayMovie.VB_HelpID = 2035
Attribute PlayMovie.VB_Description = "Plays the movie stream."
'##BD Plays the movie stream.

'##PD StartingPosition Position in the stream which to start at. If set or left at zero the stream will play from the beginning.
    On Error GoTo Handler
        
    'Assign specified starting position.
    If CLng(mvarMediaPosition.CurrentPosition) < CLng(StartingPosition) Then
        mvarMediaPosition.CurrentPosition = StartingPosition
    ElseIf CLng(mvarMediaPosition.CurrentPosition) = CLng(mvarMediaPosition.Duration) Then
        mvarMediaPosition.CurrentPosition = StartingPosition
    End If
    Call mvarMediaControl.Run
    mvarIsPlaying = True
    Call VEngine.FireEvent(2, Me)
    Exit Sub
    
Handler:
    Call VEngine.FireErrorEvent(Err.Number, Err.Description, "Movie8 | PlayMovie Method")
    mvarIsPlaying = False
End Sub

Public Sub PauseMovie()
Attribute PauseMovie.VB_HelpID = 2036
Attribute PauseMovie.VB_Description = "Pauses the play of the movie stream."
'##BD Pauses the play of the movie stream.
    On Error GoTo Handler
    
    Call mvarMediaControl.Pause
    mvarIsPlaying = False
    Call VEngine.FireEvent(3, Me)
    Exit Sub
    
Handler:
    Call VEngine.FireErrorEvent(Err.Number, Err.Description, "Movie8 | PauseMovie Method")
    mvarIsPlaying = False
End Sub

Public Sub StopMovie()
Attribute StopMovie.VB_HelpID = 2037
Attribute StopMovie.VB_Description = "Stops the playing of the stream. This will reset the streams position back to zero."
'##BD Stops the playing of the stream. This will reset the streams position back to zero.
    On Error GoTo Handler
    
    Call mvarMediaControl.Stop
    mvarMediaPosition.CurrentPosition = 0
    mvarIsPlaying = False
    Call VEngine.FireEvent(4, Me)
    Exit Sub
    
Handler:
    Call VEngine.FireErrorEvent(Err.Number, Err.Description, "Movie8 | StopMovie Method")
    mvarIsPlaying = False
End Sub
