VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MovieEngine8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'##CD Main movie object.
Attribute VB_HelpID=2002
Attribute VB_Description="Main movie object."
Option Explicit

'local variable(s) to hold property value(s)
Private mvarMovies As Movies8

'Events===============================
Public Event OnError(ErrNumber As Long, ErrDescription As String, ErrLocation As String)
Attribute OnError.VB_HelpID = 2003
Attribute OnError.VB_Description = "Fires when an error occurs."
'##ED Fires when an error occurs.
'##PD ErrNumber Error number.
'##PD ErrDescription Error Description.
'##PD ErrLocation Location (Class and Method/Property) the error occured in.

Public Event MovieLoaded(Movie As Movie8)
Attribute MovieLoaded.VB_HelpID = 2004
Attribute MovieLoaded.VB_Description = "Fires when a movie is loaded into the Movies collection."
'##ED Fires when a movie is loaded into the Movies collection.
'##PD Movie Movie that was loaded.

Public Event MoviePlaying(Movie As Movie8)
Attribute MoviePlaying.VB_HelpID = 2005
Attribute MoviePlaying.VB_Description = "Fires when a movie played."
'##ED Fires when a movie played.
'##PD Movie Movie that is playing.

Public Event MoviePaused(Movie As Movie8)
Attribute MoviePaused.VB_HelpID = 2006
Attribute MoviePaused.VB_Description = "Fires when a movie is paused."
'##ED Fires when a movie is paused.
'##PD Movie Movie that was paused.

Public Event MovieStopped(Movie As Movie8)
Attribute MovieStopped.VB_HelpID = 2007
Attribute MovieStopped.VB_Description = "Fires when a movie has stopped."
'##ED Fires when a movie has stopped.
'##PD Movie Movie that was stopped.

Friend Sub FireErrorEvent(ByVal ErrNum As Long, ByVal ErrDesc As String, ByVal Location As String)
    RaiseEvent OnError(ErrNum, ErrDesc, Location) 'Fire error event.
End Sub

Friend Sub FireEvent(eEvent As Long, Optional Movie As Movie8)
    Select Case eEvent
        Case 1 'VideoLoaded
            RaiseEvent MovieLoaded(Movie)
    
        Case 2 'MoviePlaying
            RaiseEvent MoviePlaying(Movie)
        
        Case 3 'MoviePaused
            RaiseEvent MoviePaused(Movie)
        
        Case 4 'MovieStopped
            RaiseEvent MovieStopped(Movie)
            
    End Select
End Sub

Public Property Get Movies() As Movies8
Attribute Movies.VB_HelpID = 2008
Attribute Movies.VB_Description = "Returns the collection of  Movie8 objects."
'##BD Returns the collection of  Movie8 objects.
    Set Movies = mvarMovies
End Property

Private Sub Class_Initialize()
    Set VEngine = Me
    
    Set mvarMovies = New Movies8
End Sub

Private Sub Class_Terminate()
    On Error Resume Next
    
    Set VEngine = Nothing
    Set mvarMovies = Nothing
End Sub

